diff --git a/CMakeLists.txt b/CMakeLists.txt
index 5080b70..2b5e5bf 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -6,6 +6,7 @@ SET(CMAKE_INCLUDE_CURRENT_DIR TRUE)
 IF(UNIX)
  SET(LINUX_SET TRUE)
  ADD_DEFINITIONS(-D LINUX)
+ ADD_DEFINITIONS(-D QT3_SUPPORT)
 ENDIF(UNIX)
 
 add_subdirectory(tmolib/)
diff --git a/TMOW32/TMOW32.cpp b/TMOW32/TMOW32.cpp
index 979795b..bf23e3b 100644
--- a/TMOW32/TMOW32.cpp
+++ b/TMOW32/TMOW32.cpp
@@ -12,7 +12,7 @@ map<wstring,HMODULE> mapModules;
 
 #define MAX_OPERATORS 256
 
-BOOL APIENTRY DllMain( HANDLE hModule, 
+BOOL APIENTRY DllMain( Qt::HANDLE hModule, 
                        DWORD  ul_reason_for_call, 
                        LPVOID lpReserved
 					 )
diff --git a/TMOgui/CMakeLists.txt b/TMOgui/CMakeLists.txt
index 58fbb67..166e76e 100644
--- a/TMOgui/CMakeLists.txt
+++ b/TMOgui/CMakeLists.txt
@@ -9,51 +9,14 @@ IF(UNIX AND NOT LINUX_SET)
  ADD_DEFINITIONS(-D LINUX)
 ENDIF(UNIX AND NOT LINUX_SET)
 
+ADD_DEFINITIONS(-D QT3_SUPPORT)
+
 if(COMMAND cmake_policy)
   cmake_policy(SET CMP0003 NEW)
 endif(COMMAND cmake_policy)
 
-SET (QT_MT_REQUIRED true)
-SET (QT_MIN_VERSION "3.3.8")
-FIND_PACKAGE(Qt3 REQUIRED)
-IF (QT_FOUND)
-	#SET(QT_UIC_EXECUTABLE "$ENV{QTDIR}/bin/uic") #did not find correct uic on Fedora
-
-# Qt 3 should prefer QTDIR over the PATH
-find_program(MY_QT_UIC_EXECUTABLE
-  NAMES uic-qt3 uic uic3 uic3-mt 
-  HINTS
-    ENV QTDIR
-  PATHS
-  "[HKEY_CURRENT_USER\\Software\\Trolltech\\Qt3Versions\\3.2.1;InstallDir]/include/Qt"
-  "[HKEY_CURRENT_USER\\Software\\Trolltech\\Qt3Versions\\3.2.0;InstallDir]/include/Qt"
-  "[HKEY_CURRENT_USER\\Software\\Trolltech\\Qt3Versions\\3.1.0;InstallDir]/include/Qt"
-  ${GLOB_PATHS_BIN}
-    /usr/local/qt
-    /usr/lib/qt
-    /usr/lib/qt3
-    /usr/share/qt3
-    C:/Progra~1/qt
-    /usr/X11R6
-  PATH_SUFFIXES
-    bin
-  )
-
-  SET(QT_UIC_EXECUTABLE ${MY_QT_UIC_EXECUTABLE})
-	
-  MESSAGE("Qt3 Found OK ${QT_VERSION_STR}")
-   MESSAGE("$ENV{QTDIR}")
-   MESSAGE("${QT_MOC_EXECUTABLE}")
-   MESSAGE("${QT_UIC_EXECUTABLE}")
-   MESSAGE("${QT_QT_LIBRARY}")
-   MESSAGE("${QT_INCLUDE_DIR}")
-  MESSAGE("${qt_version_str}")
-   MESSAGE(${qt_version_str_lib})
-  ADD_DEFINITIONS(${QT_DEFINITIONS})
-ELSE(QT_FOUND)
-  MESSAGE(FATAL_ERROR "No Qt3")
-ENDIF(QT_FOUND)
-
+SET (QT_MIN_VERSION "4.8.0")
+FIND_PACKAGE(Qt4 REQUIRED)
 
 INCLUDE_DIRECTORIES(
 ${CMAKE_BINARY_DIR}
diff --git a/TMOgui/TMOGUIAdjust.cpp b/TMOgui/TMOGUIAdjust.cpp
index 291f363..53d969c 100644
--- a/TMOgui/TMOGUIAdjust.cpp
+++ b/TMOgui/TMOGUIAdjust.cpp
@@ -14,6 +14,10 @@
 #include <qlineedit.h>
 #include <qlabel.h>
 #include <qtooltip.h>
+//Added by qt3to4:
+#include <Q3HBoxLayout>
+#include <Q3GridLayout>
+#include <Q3Frame>
 #include "gamma.h"
 
 //#include <iostream>
@@ -23,15 +27,15 @@
 //////////////////////////////////////////////////////////////////////
 
 TMOGUIAdjust::TMOGUIAdjust(QWidget* parent, const char * name):
-	QFrame(parent, name)
+	Q3Frame(parent, name)
 {
 	iMode = 0;
 	pValues = 0;
 	bLog = true;
 	bUpdate = false;
 
-	setFrameStyle( QFrame::Panel | QFrame::Sunken );
-	QGridLayout *pLayout = new QGridLayout(this, 8, 4);
+	setFrameStyle( Q3Frame::Panel | Q3Frame::Sunken );
+	Q3GridLayout *pLayout = new Q3GridLayout(this, 8, 4);
 	pLayout->setColStretch(0,0);
 	pLayout->setColStretch(1,1);
 	pLayout->setColStretch(2,0);
@@ -42,13 +46,13 @@ TMOGUIAdjust::TMOGUIAdjust(QWidget* parent, const char * name):
 	pSlider->setFixedSize(16,64);
 	pSlider->setRange(-50, 50);
 	pSlider->setValue(0);
-	pSlider->setOrientation(Vertical);
-	pSlider->setTickmarks(QSlider::Right);
+	pSlider->setOrientation(Qt::Vertical);
+	pSlider->setTickmarks(QSlider::TicksRight);
 	pSlider->setTickInterval(10);
 	pLayout->addMultiCellWidget(pSlider, 0, 3, 0, 0);
 
 	pHisto = new TMOGUIHisto(this, "Histogram");
-	pLayout->addMultiCellWidget(pHisto, 0, 3, 1, 1, AlignBottom);
+	pLayout->addMultiCellWidget(pHisto, 0, 3, 1, 1, Qt::AlignBottom);
 
 	pLayout->addRowSpacing(4, 2);
 
@@ -60,49 +64,49 @@ TMOGUIAdjust::TMOGUIAdjust(QWidget* parent, const char * name):
 	pRed->setFixedSize(16,16);
 	pRed->setPixmap(*TMOResource::pResource->IconRed->pixmap());
 	QToolTip::add(pRed, "Select Red Channel");
-	pLayout->addWidget(pRed, 0, 2, AlignCenter);
+	pLayout->addWidget(pRed, 0, 2, Qt::AlignCenter);
 	
 	pGreen = new QPushButton(this, "GreenButton");
 	pGreen->setFlat(true);
 	pGreen->setFixedSize(16,16);
 	pGreen->setPixmap(*TMOResource::pResource->IconGreen->pixmap());
 	QToolTip::add(pGreen, "Select Green Channel");
-	pLayout->addWidget(pGreen, 1, 2, AlignCenter);
+	pLayout->addWidget(pGreen, 1, 2, Qt::AlignCenter);
 
 	pBlue = new QPushButton(this, "BlueButton");
 	pBlue->setFlat(true);
 	pBlue->setFixedSize(16,16);
 	pBlue->setPixmap(*TMOResource::pResource->IconBlue->pixmap());
 	QToolTip::add(pBlue, "Select Blue Channel");
-	pLayout->addWidget(pBlue, 2, 2, AlignCenter);
+	pLayout->addWidget(pBlue, 2, 2, Qt::AlignCenter);
 
 	pLum = new QPushButton(this, "LumButton");
 	pLum->setFlat(true);
 	pLum->setFixedSize(16,16);
 	pLum->setPixmap(*TMOResource::pResource->IconLumDown->pixmap());	
 	QToolTip::add(pLum, "Select Luminance");
-	pLayout->addWidget(pLum, 3, 2, AlignCenter);
+	pLayout->addWidget(pLum, 3, 2, Qt::AlignCenter);
 	
 	pLinear = new QPushButton(this, "LinearButton");
 	pLinear->setFlat(true);
 	pLinear->setFixedSize(32,32);
 	pLinear->setPixmap(*TMOResource::pResource->IconLin->pixmap());
 	QToolTip::add(pLinear, "View In Linear Distribution");
-	pLayout->addMultiCellWidget(pLinear, 0, 1, 3, 3, AlignCenter);
+	pLayout->addMultiCellWidget(pLinear, 0, 1, 3, 3, Qt::AlignCenter);
 
 	pLog = new QPushButton(this, "LogarithmicButton");
 	pLog->setFlat(true);
 	pLog->setFixedSize(32,32);
 	pLog->setPixmap(*TMOResource::pResource->IconLogDown->pixmap());
 	QToolTip::add(pLog, "View In Logarithmic Distribution");
-	pLayout->addMultiCellWidget(pLog, 2, 3, 3, 3, AlignCenter);
+	pLayout->addMultiCellWidget(pLog, 2, 3, 3, 3, Qt::AlignCenter);
 	
 	pLayout->addRowSpacing(6, 2);
 
-	QHBoxLayout* hbox = new QHBoxLayout();
+	Q3HBoxLayout* hbox = new Q3HBoxLayout();
 	QLabel* pLabel = new QLabel(this, "BlackLabel");
 	pLabel->setPixmap(*TMOResource::pResource->IconBlack->pixmap());
-	pLabel->setFrameStyle( QFrame::Panel | QFrame::Sunken );
+	pLabel->setFrameStyle( Q3Frame::Panel | Q3Frame::Sunken );
 	hbox->addWidget(pLabel);
 	pBlack = new QLineEdit(this, "EditBlack");
 	pBlack->setAlignment(Qt::AlignRight);
@@ -111,7 +115,7 @@ TMOGUIAdjust::TMOGUIAdjust(QWidget* parent, const char * name):
 	hbox->insertStretch(-1,1);
 	pLabel = new QLabel(this, "GammaLabel");
 	pLabel->setPixmap(*TMOResource::pResource->IconGamma->pixmap());
-	pLabel->setFrameStyle( QFrame::Panel | QFrame::Sunken );
+	pLabel->setFrameStyle( Q3Frame::Panel | Q3Frame::Sunken );
 	hbox->addWidget(pLabel);
 	pGamma = new QLineEdit(this, "EditGamma");
 	pGamma->setAlignment(Qt::AlignRight);
@@ -120,7 +124,7 @@ TMOGUIAdjust::TMOGUIAdjust(QWidget* parent, const char * name):
 	hbox->insertStretch(-1,1);
 	pLabel = new QLabel(this, "WhiteLabel");
 	pLabel->setPixmap(*TMOResource::pResource->IconWhite->pixmap());
-	pLabel->setFrameStyle( QFrame::Panel | QFrame::Sunken );
+	pLabel->setFrameStyle( Q3Frame::Panel | Q3Frame::Sunken );
 	hbox->addWidget(pLabel);
 	pWhite = new QLineEdit(this, "EditWhite");
 	pWhite->setAlignment(Qt::AlignRight);
diff --git a/TMOgui/TMOGUIAdjust.h b/TMOgui/TMOGUIAdjust.h
index f935c59..ff66a28 100644
--- a/TMOgui/TMOGUIAdjust.h
+++ b/TMOgui/TMOGUIAdjust.h
@@ -1,7 +1,7 @@
 // TMOGUIAdjust.h: interface for the TMOGUIAdjust class.
 //
 //////////////////////////////////////////////////////////////////////
-#include <qframe.h>
+#include <q3frame.h>
 #include "TMOGUIAdjustValues.h"
 
 class TMOImage;
@@ -12,7 +12,7 @@ class QLineEdit;
 class QPushButton;
 class QString;
 
-class TMOGUIAdjust : public QFrame
+class TMOGUIAdjust : public Q3Frame
 {
 	Q_OBJECT
 public:
diff --git a/TMOgui/TMOGUIBitmap.cpp b/TMOgui/TMOGUIBitmap.cpp
index 42c5acc..5e45006 100644
--- a/TMOgui/TMOGUIBitmap.cpp
+++ b/TMOgui/TMOGUIBitmap.cpp
@@ -13,6 +13,11 @@
 #include <qlabel.h>
 #include <qcursor.h>
 #include <qapplication.h>
+//Added by qt3to4:
+#include <QContextMenuEvent>
+#include <QPaintEvent>
+#include <QMouseEvent>
+#include <QEvent>
 #include <math.h>
 #include <float.h>
 
@@ -31,7 +36,7 @@
 //////////////////////////////////////////////////////////////////////
 
 TMOGUIBitmap::TMOGUIBitmap(QWidget * parent, const char * name):
-	QWidget(parent, name, WRepaintNoErase | WResizeNoErase)
+	QWidget(parent, name, Qt::WNoAutoErase | Qt::WResizeNoErase)
 {
 	setFixedSize(INITIAL_BITMAP_WIDTH, INITIAL_BITMAP_HEIGHT);
 	dRatio = 1;
@@ -244,12 +249,12 @@ int TMOGUIBitmap::Render(bool bRepaint)
 		pValues->dGAverage /= iTotal;
 		pValues->dBAverage /= iTotal;
 		pSrc->ProgressBar(0, 0);
-		pSrcPixmap->convertFromImage(pImage, AutoColor|OrderedDither|OrderedAlphaDither);
+		pSrcPixmap->convertFromImage(pImage, Qt::AutoColor|Qt::OrderedDither|Qt::OrderedAlphaDither);
 	}
 	if ((pSrc->GetWidth()!=s.width())||(pSrc->GetHeight()!=s.height())) 
 	{
 		QPixmap tempPixmap(*pSrcPixmap);
-        QWMatrix m;
+        QMatrix m;
         m.scale((double)s.width() / pSrcPixmap->width(),
                 (double)s.height() / pSrcPixmap->height());
         *pPixmap = tempPixmap.xForm(m);
diff --git a/TMOgui/TMOGUIBitmap.h b/TMOgui/TMOGUIBitmap.h
index bb83098..9809f72 100644
--- a/TMOgui/TMOGUIBitmap.h
+++ b/TMOgui/TMOGUIBitmap.h
@@ -2,6 +2,12 @@
 //
 //////////////////////////////////////////////////////////////////////
 #include <qwidget.h>
+//Added by qt3to4:
+#include <QPixmap>
+#include <QEvent>
+#include <QMouseEvent>
+#include <QContextMenuEvent>
+#include <QPaintEvent>
 
 class QPixmap;
 class QSize;
diff --git a/TMOgui/TMOGUICenterView.cpp b/TMOgui/TMOGUICenterView.cpp
index 2bb1e30..5184cc4 100644
--- a/TMOgui/TMOGUICenterView.cpp
+++ b/TMOgui/TMOGUICenterView.cpp
@@ -3,13 +3,15 @@
 //////////////////////////////////////////////////////////////////////
 
 #include "TMOGUICenterView.h"
+//Added by qt3to4:
+#include <QPaintEvent>
 
 //////////////////////////////////////////////////////////////////////
 // Construction/Destruction
 //////////////////////////////////////////////////////////////////////
 
-TMOGUICenterView::TMOGUICenterView(QWidget * parent, const char * name, WFlags f)
-	:QScrollView(parent, name, f)
+TMOGUICenterView::TMOGUICenterView(QWidget * parent, const char * name, Qt::WFlags f)
+	:Q3ScrollView(parent, name, f)
 {
 	bZooming = false;
 }
diff --git a/TMOgui/TMOGUICenterView.h b/TMOgui/TMOGUICenterView.h
index 85a0513..ccb0b73 100644
--- a/TMOgui/TMOGUICenterView.h
+++ b/TMOgui/TMOGUICenterView.h
@@ -1,14 +1,16 @@
 // TMOGUICenterView.h: interface for the TMOGUICenterView class.
 //
 //////////////////////////////////////////////////////////////////////
-#include <qscrollview.h>
+#include <q3scrollview.h>
+//Added by qt3to4:
+#include <QPaintEvent>
 
-class TMOGUICenterView : public QScrollView  
+class TMOGUICenterView : public Q3ScrollView  
 {
 	Q_OBJECT
 public:
 	virtual void Zoom(bool bZoom = true);
-	TMOGUICenterView(QWidget * parent=0, const char * name=0, WFlags f=0 );
+	TMOGUICenterView(QWidget * parent=0, const char * name=0, Qt::WFlags f=0 );
 	virtual ~TMOGUICenterView();
 protected:
 	virtual void viewportPaintEvent ( QPaintEvent * pe );
diff --git a/TMOgui/TMOGUIFileToolBar.cpp b/TMOgui/TMOGUIFileToolBar.cpp
index 0da5807..61a8096 100644
--- a/TMOgui/TMOGUIFileToolBar.cpp
+++ b/TMOgui/TMOGUIFileToolBar.cpp
@@ -13,7 +13,7 @@
 // Construction/Destruction
 //////////////////////////////////////////////////////////////////////
 
-TMOGUIFileToolBar::TMOGUIFileToolBar(QWidget * parent, const char * name):QToolBar((QMainWindow*)parent, name)
+TMOGUIFileToolBar::TMOGUIFileToolBar(QWidget * parent, const char * name):Q3ToolBar((Q3MainWindow*)parent, name)
 {
 	pParent = parent;
 	Create();
diff --git a/TMOgui/TMOGUIFileToolBar.h b/TMOgui/TMOGUIFileToolBar.h
index 7af06bb..f9ac593 100644
--- a/TMOgui/TMOGUIFileToolBar.h
+++ b/TMOgui/TMOGUIFileToolBar.h
@@ -4,7 +4,7 @@
 #ifndef __TMOGUIFileToolBar_H
 #define __TMOGUIFileToolBar_H
 
-#include <qtoolbar.h>
+#include <q3toolbar.h>
 class QWorkspace;
 class QToolButton;
 
@@ -13,7 +13,7 @@ class QToolButton;
  *
  * Group of tools for file manipulations. Inherits from QToolBar.
  */
-class TMOGUIFileToolBar : public QToolBar
+class TMOGUIFileToolBar : public Q3ToolBar
 {
 	Q_OBJECT	
 public:
diff --git a/TMOgui/TMOGUIFilters.cpp b/TMOgui/TMOGUIFilters.cpp
index 99282a1..82ab7fb 100644
--- a/TMOgui/TMOGUIFilters.cpp
+++ b/TMOgui/TMOGUIFilters.cpp
@@ -11,17 +11,19 @@
 #include <qlayout.h>
 #include <qradiobutton.h>
 #include <qpushbutton.h>
-#include <qbuttongroup.h>
+#include <q3buttongroup.h>
 #include <qcheckbox.h>
-#include <qgroupbox.h>
+#include <q3groupbox.h>
 #include <qpixmap.h>
 #include <qslider.h>
 #include <qcolordialog.h>
+//Added by qt3to4:
+#include <Q3GridLayout>
 //////////////////////////////////////////////////////////////////////
 // Construction/Destruction
 //////////////////////////////////////////////////////////////////////
 
-TMOGUIFilters::TMOGUIFilters( QWidget* parent, const char* name, WFlags f ):
+TMOGUIFilters::TMOGUIFilters( QWidget* parent, const char* name, Qt::WFlags f ):
 	QWidget(parent, name, f)
 {
 	pWhite = pRWhite = pGWhite = pBWhite = 0;
@@ -40,9 +42,9 @@ TMOGUIFilters::~TMOGUIFilters()
 int TMOGUIFilters::Create()
 {
 	QRadioButton *pRadio;
-	QButtonGroup *pButtonGroup;
+	Q3ButtonGroup *pButtonGroup;
 
-	pLayout = new QGridLayout(this,24,7);
+	pLayout = new Q3GridLayout(this,24,7);
 
 	pLayout->addColSpacing(0,10);
 	pLayout->addColSpacing(6,10);
@@ -62,7 +64,7 @@ int TMOGUIFilters::Create()
 	pLayout->setColStretch(6,0);
 	pLayout->setRowStretch(17,1);
 	
-	pButtonGroup = new QButtonGroup("Threshold", this, "GroupButton");
+	pButtonGroup = new Q3ButtonGroup("Threshold", this, "GroupButton");
 	pLayout->addMultiCellWidget(pButtonGroup,1,4,1,5);
 
 	pRadio = new QRadioButton( "Luminance", this, "LuminanceButton" );
@@ -77,13 +79,13 @@ int TMOGUIFilters::Create()
 
 	pLuminance = new QLabel("Luminannce", this);
 	pLayout->addMultiCellWidget(pLuminance,6,6,1,6);
-	pBlackScroll = new QScrollBar(QScrollBar::Horizontal, this, "BlackScrollBar");
+	pBlackScroll = new QScrollBar(Qt::Horizontal, this, "BlackScrollBar");
 	pBlackScroll->setRange(0, 100);
 	pLayout->addWidget(pBlackScroll,7,1);
 	pBlack = new QLineEdit( this, "BlackEdit" );
 	pBlack->setFixedWidth(48);
 	pLayout->addWidget(pBlack,7,2);
-	pWhiteScroll = new QScrollBar(QScrollBar::Horizontal, this, "WhiteScrollBar");
+	pWhiteScroll = new QScrollBar(Qt::Horizontal, this, "WhiteScrollBar");
 	pWhiteScroll->setRange(0, 100);
 	pLayout->addWidget(pWhiteScroll,7,4);
 	pWhite = new QLineEdit( this, "WhiteEdit" );
@@ -92,13 +94,13 @@ int TMOGUIFilters::Create()
 	
 	pRed = new QLabel("Red", this);
 	pLayout->addMultiCellWidget(pRed,8,8,1,6);
-	pRBlackScroll = new QScrollBar(QScrollBar::Horizontal, this, "RBlackScrollBar");
+	pRBlackScroll = new QScrollBar(Qt::Horizontal, this, "RBlackScrollBar");
 	pRBlackScroll->setRange(0, 100);
 	pLayout->addWidget(pRBlackScroll,9,1);
 	pRBlack = new QLineEdit( this, "RBlackEdit" );
 	pRBlack->setFixedWidth(48);
 	pLayout->addWidget(pRBlack,9,2);
-	pRWhiteScroll = new QScrollBar(QScrollBar::Horizontal, this, "RWhiteScrollBar");
+	pRWhiteScroll = new QScrollBar(Qt::Horizontal, this, "RWhiteScrollBar");
 	pRWhiteScroll->setRange(0, 100);
 	pLayout->addWidget(pRWhiteScroll,9,4);
 	pRWhite = new QLineEdit( this, "RWhiteEdit" );
@@ -107,13 +109,13 @@ int TMOGUIFilters::Create()
 
 	pGreen = new QLabel("Green", this);
 	pLayout->addMultiCellWidget(pGreen,10,10,1,6);
-	pGBlackScroll = new QScrollBar(QScrollBar::Horizontal, this, "RBlackScrollBar");
+	pGBlackScroll = new QScrollBar(Qt::Horizontal, this, "RBlackScrollBar");
 	pGBlackScroll->setRange(0, 100);
 	pLayout->addWidget(pGBlackScroll,11,1);
 	pGBlack = new QLineEdit( this, "RBlackEdit" );
 	pGBlack->setFixedWidth(48);
 	pLayout->addWidget(pGBlack,11,2);
-	pGWhiteScroll = new QScrollBar(QScrollBar::Horizontal, this, "RWhiteScrollBar");
+	pGWhiteScroll = new QScrollBar(Qt::Horizontal, this, "RWhiteScrollBar");
 	pGWhiteScroll->setRange(0, 100);
 	pLayout->addWidget(pGWhiteScroll,11,4);
 	pGWhite = new QLineEdit( this, "RWhiteEdit" );
@@ -122,13 +124,13 @@ int TMOGUIFilters::Create()
 
 	pBlue = new QLabel("Blue", this);
 	pLayout->addMultiCellWidget(pBlue,12,12,1,6);
-	pBBlackScroll = new QScrollBar(QScrollBar::Horizontal, this, "RBlackScrollBar");
+	pBBlackScroll = new QScrollBar(Qt::Horizontal, this, "RBlackScrollBar");
 	pBBlackScroll->setRange(0, 100);
 	pLayout->addWidget(pBBlackScroll,13,1);
 	pBBlack = new QLineEdit( this, "RBlackEdit" );
 	pBBlack->setFixedWidth(48);
 	pLayout->addWidget(pBBlack,13,2);
-	pBWhiteScroll = new QScrollBar(QScrollBar::Horizontal, this, "RWhiteScrollBar");
+	pBWhiteScroll = new QScrollBar(Qt::Horizontal, this, "RWhiteScrollBar");
 	pBWhiteScroll->setRange(0, 100);
 	pLayout->addWidget(pBWhiteScroll,13,4);
 	pBWhite = new QLineEdit( this, "RWhiteEdit" );
@@ -145,12 +147,12 @@ int TMOGUIFilters::Create()
 	QLabel* pLabel = new QLabel("Intensity", this, "FilterInt");
 	pLayout->addMultiCellWidget(pLabel, 19, 19, 1, 2);
 	pLabel = new QLabel("Color", this, "ColorLabel");
-	pLayout->addWidget(pLabel, 19,5, AlignHCenter );
+	pLayout->addWidget(pLabel, 19,5, Qt::AlignHCenter );
 
 	pPixmap = new QPixmap(32,24);
 	pPixmap->fill(QColor(255,0,0));
 
-	pSlider = new QSlider(QSlider::Horizontal, this, "Color");
+	pSlider = new QSlider(Qt::Horizontal, this, "Color");
 	pSlider->setRange(0,100);
 	pLayout->addMultiCellWidget(pSlider, 20, 20, 1, 4);
 
@@ -163,12 +165,12 @@ int TMOGUIFilters::Create()
 	pEnable->setToggleButton(true);
 	pEnable->setFixedHeight(24);
 	pEnable->setFixedWidth(64);
-	pLayout->addWidget(pEnable, 22, 2, AlignRight);
+	pLayout->addWidget(pEnable, 22, 2, Qt::AlignRight);
 
 	QPushButton *pReset = new QPushButton("Reset", this, "ResetFilters");
 	pReset->setFixedHeight(24);
 	pReset->setFixedWidth(64);
-	pLayout->addMultiCellWidget(pReset, 22, 22, 4, 5, AlignLeft);
+	pLayout->addMultiCellWidget(pReset, 22, 22, 4, 5, Qt::AlignLeft);
 
 	component();
 
diff --git a/TMOgui/TMOGUIFilters.h b/TMOgui/TMOGUIFilters.h
index d2a9a95..0e5a294 100644
--- a/TMOgui/TMOGUIFilters.h
+++ b/TMOgui/TMOGUIFilters.h
@@ -4,12 +4,16 @@
 
 #include "TMOGUIAdjustValues.h"
 #include <qwidget.h>
+//Added by qt3to4:
+#include <QPixmap>
+#include <Q3GridLayout>
+#include <QLabel>
 class QComboBox;
 class TMOGUIImage;
 class QPushButton;
 class QLineEdit;
 class QLabel;
-class QGridLayout;
+class Q3GridLayout;
 class QCheckBox;
 class QPixmap;
 class QSlider;
@@ -19,7 +23,7 @@ class TMOGUIFilters : public QWidget
 {
 	Q_OBJECT
 public:
-	TMOGUIFilters(QWidget* parent = 0, const char* name = 0, WFlags f = 0 );
+	TMOGUIFilters(QWidget* parent = 0, const char* name = 0, Qt::WFlags f = 0 );
 	virtual ~TMOGUIFilters();
 
 protected:
@@ -34,7 +38,7 @@ protected:
 
 	QLabel *pLuminance, *pRed, *pGreen, *pBlue;
 	TMOGUIImage *pImage;
-	QGridLayout* pLayout;
+	Q3GridLayout* pLayout;
 	QPixmap* pPixmap;
 	QPushButton *pColor;
 	QPushButton *pEnable;
diff --git a/TMOgui/TMOGUIHisto.cpp b/TMOgui/TMOGUIHisto.cpp
index 228e9cd..ea0b225 100644
--- a/TMOgui/TMOGUIHisto.cpp
+++ b/TMOgui/TMOGUIHisto.cpp
@@ -7,6 +7,9 @@
 #include "TMOGUIAdjustValues.h"
 #include <qpainter.h>
 #include <qpixmap.h>
+//Added by qt3to4:
+#include <QResizeEvent>
+#include <QPaintEvent>
 #include <math.h>
 
 //////////////////////////////////////////////////////////////////////
@@ -14,7 +17,7 @@
 //////////////////////////////////////////////////////////////////////
 
 TMOGUIHisto::TMOGUIHisto(QWidget* parent, const char * name):
-	QWidget(parent, name, WRepaintNoErase | WResizeNoErase)
+	QWidget(parent, name, Qt::WNoAutoErase | Qt::WResizeNoErase)
 {
 	bLog = true;
 	iMode = 0;
diff --git a/TMOgui/TMOGUIHisto.h b/TMOgui/TMOGUIHisto.h
index 7bbc6c3..40e41dc 100644
--- a/TMOgui/TMOGUIHisto.h
+++ b/TMOgui/TMOGUIHisto.h
@@ -2,6 +2,10 @@
 //
 //////////////////////////////////////////////////////////////////////
 #include <qwidget.h>
+//Added by qt3to4:
+#include <QPaintEvent>
+#include <QResizeEvent>
+#include <QPixmap>
 
 #define HISTOGRAM_WIDTH 256
 #define COMPONENTS_COUNT 3
diff --git a/TMOgui/TMOGUIImage.cpp b/TMOgui/TMOGUIImage.cpp
index 726b30a..65ae9f0 100644
--- a/TMOgui/TMOGUIImage.cpp
+++ b/TMOgui/TMOGUIImage.cpp
@@ -15,12 +15,16 @@
 #include <qstatusbar.h>
 #include <qapplication.h>
 #include <qpushbutton.h>
-#include <qscrollview.h>
+#include <q3scrollview.h>
 #include <qlabel.h>
 #include <qtooltip.h>
 #include <qfont.h>
 #include <qcursor.h>
 #include <qmessagebox.h>
+//Added by qt3to4:
+#include <QCustomEvent>
+#include <QResizeEvent>
+#include <QEvent>
 #include <math.h>
 #include "TMOGUIImage.h"
 
@@ -40,7 +44,7 @@ wchar_t buffer[256];
 //////////////////////////////////////////////////////////////////////
 
 TMOGUIImage::TMOGUIImage(TMOGUIProgressBar *pInitBar, QWidget* parent, const char * name):
-	QVBox(parent, name)
+	Q3VBox(parent, name)
 {
 	pInitProgress = pInitBar;
 	pImage = 0;
@@ -55,7 +59,7 @@ TMOGUIImage::TMOGUIImage(TMOGUIProgressBar *pInitBar, QWidget* parent, const cha
 	setIcon(*TMOResource::pResource->IconMain->pixmap());
 
 	// Scrollview
-	pScrollView = new QScrollView(this, "Scrollview",  WRepaintNoErase|WResizeNoErase|WNorthWestGravity);
+	pScrollView = new Q3ScrollView(this, "Scrollview",  Qt::WNoAutoErase|Qt::WResizeNoErase|Qt::WStaticContents);
 
 	// Image
 	pImage = new TMOGUIBitmap(pScrollView->viewport(), "Bitmap");
@@ -79,7 +83,7 @@ TMOGUIImage::TMOGUIImage(TMOGUIProgressBar *pInitBar, QWidget* parent, const cha
 
 	// Statusbar
 	pStatus = new QStatusBar(this, "Statusbar");
-	pHBox = new QHBox(pStatus, "Statushbox");
+	pHBox = new Q3HBox(pStatus, "Statushbox");
 	pTransformLabel = new QLabel("Mapping...", pHBox, "TMOflag");
 	pTransformLabel->hide();
 	pZoom = new QLabel("100%", pHBox, "Zoomlabel");
@@ -457,7 +461,7 @@ void TMOGUIImage::zoomOut()
 
 void TMOGUIImage::setsize()
 {
-	QSize s = QVBox::size();
+	QSize s = Q3VBox::size();
 
 	if (bMaximized) 
 	{
@@ -485,7 +489,7 @@ void TMOGUIImage::resizeEvent ( QResizeEvent * re )
 {
 	if (re->size() == pParent->size()) bMaximized = true;
 	else bMaximized = false;
-	QVBox::resizeEvent(re);
+	Q3VBox::resizeEvent(re);
 }
 
 void TMOGUIImage::showtools()
diff --git a/TMOgui/TMOGUIImage.h b/TMOgui/TMOGUIImage.h
index 86707ec..0853453 100644
--- a/TMOgui/TMOGUIImage.h
+++ b/TMOgui/TMOGUIImage.h
@@ -4,7 +4,11 @@
 
 #ifndef TMOGUIIMAGE_H
 #define TMOGUIIMAGE_H
-#include <qvbox.h>
+#include <q3vbox.h>
+//Added by qt3to4:
+#include <QResizeEvent>
+#include <QCustomEvent>
+#include <QLabel>
 #include <string>
 #include "TMOGUIBitmap.h"
 #include "TMOGUIAdjustValues.h"
@@ -13,7 +17,7 @@
 //using namespace std;
 
 class QPushButton;
-class QScrollView;
+class Q3ScrollView;
 class QStatusBar;
 class QLabel;
 class TMOGUIProgressBar;
@@ -21,7 +25,7 @@ class TMOGUIOutput;
 class TMOGUIAdjust;
 class TMOGUITransformation;
 
-class TMOGUIImage : public QVBox  
+class TMOGUIImage : public Q3VBox  
 {
 	Q_OBJECT
 public:
@@ -58,7 +62,7 @@ protected:
 	virtual void customEvent( QCustomEvent * e );
 	virtual void resizeEvent ( QResizeEvent * );
 	QSize size;
-	QScrollView* pScrollView;
+	Q3ScrollView* pScrollView;
 	QLabel* pZoom;
 	TMOGUIProgressBar* pProgress;
 	TMOGUIProgressBar *pInitProgress;
@@ -67,7 +71,7 @@ protected:
 	TMOGUITransformation *pTransform;
 	TMOImage* pSrc;
 	TMOImage* pDst;
-	QHBox* pHBox; 
+	Q3HBox* pHBox; 
 	QStatusBar *pStatus;	
 	QLabel* pTransformLabel;
 	QWidget* pParent;
diff --git a/TMOgui/TMOGUIInfo.cpp b/TMOgui/TMOGUIInfo.cpp
index accd7c7..001f6a4 100644
--- a/TMOgui/TMOGUIInfo.cpp
+++ b/TMOgui/TMOGUIInfo.cpp
@@ -7,6 +7,8 @@
 #include "TMOGUIResource.h"
 #include <qpushbutton.h>
 #include <qlabel.h>
+//Added by qt3to4:
+#include <QResizeEvent>
 
 //////////////////////////////////////////////////////////////////////
 // Construction/Destruction
diff --git a/TMOgui/TMOGUIInfo.h b/TMOgui/TMOGUIInfo.h
index a5696b6..c7fb1f4 100644
--- a/TMOgui/TMOGUIInfo.h
+++ b/TMOgui/TMOGUIInfo.h
@@ -2,11 +2,15 @@
 //
 //////////////////////////////////////////////////////////////////////
 #include <qtabwidget.h>
+//Added by qt3to4:
+#include <Q3GridLayout>
+#include <QLabel>
+#include <QResizeEvent>
 
 class TMOGUIOutput;
 class TMOGUIStatistics;
 class QPushButton;
-class QGridLayout;
+class Q3GridLayout;
 class QLabel;
 
 /*! \class TMOGUIInfo	
diff --git a/TMOgui/TMOGUIInfoPanel.cpp b/TMOgui/TMOGUIInfoPanel.cpp
index a0e36d4..fc3d698 100644
--- a/TMOgui/TMOGUIInfoPanel.cpp
+++ b/TMOgui/TMOGUIInfoPanel.cpp
@@ -3,14 +3,14 @@
 #include "TMOGUILineResizer.h"
 
 #include <qlabel.h>
-#include <qgroupbox.h>
+#include <q3groupbox.h>
 #include <qtooltip.h>
 
 
 TMOGUIInfoPanel::TMOGUIInfoPanel( QWidget* parent, const char* name )
     : QWidget( parent, name )
 {
-    groupBoxStat = new QGroupBox( this, "groupBoxStat" );
+    groupBoxStat = new Q3GroupBox( this, "groupBoxStat" );
     groupBoxStat->setGeometry( QRect( 290, 10, 130, 140 ) );
 
     pAbove = new QLabel( groupBoxStat, "pAbove" );
@@ -49,7 +49,7 @@ TMOGUIInfoPanel::TMOGUIInfoPanel( QWidget* parent, const char* name )
     pBelow = new QLabel( groupBoxStat, "pBelow" );
     pBelow->setGeometry( QRect( 70, 30, 49, 20 ) );
 
-    groupBoxHisto = new QGroupBox( this, "groupBoxHisto" );
+    groupBoxHisto = new Q3GroupBox( this, "groupBoxHisto" );
     groupBoxHisto->setGeometry( QRect( 10, 10, 270, 140 ) );
 
     pGamma = new QLabel( groupBoxHisto, "pGamma" );
@@ -88,7 +88,7 @@ TMOGUIInfoPanel::TMOGUIInfoPanel( QWidget* parent, const char* name )
     textLabelAvg_font.setBold( TRUE );
     textLabelAvg->setFont( textLabelAvg_font ); 
 
-    groupBoxLocalTool = new QGroupBox( this, "groupBoxLocalTool" );
+    groupBoxLocalTool = new Q3GroupBox( this, "groupBoxLocalTool" );
     groupBoxLocalTool->setGeometry( QRect( 430, 10, 510, 140 ) );
 
     textLabelAvgLum = new QLabel( groupBoxLocalTool, "textLabelAvgLum" );
diff --git a/TMOgui/TMOGUIInfoPanel.h b/TMOgui/TMOGUIInfoPanel.h
index e3b9e66..573b5f4 100644
--- a/TMOgui/TMOGUIInfoPanel.h
+++ b/TMOgui/TMOGUIInfoPanel.h
@@ -3,9 +3,11 @@
 #define TMOGUIINFOPANEL_H
 
 #include <qwidget.h>
+//Added by qt3to4:
+#include <QLabel>
 
 class QLabel;
-class QGroupBox;
+class Q3GroupBox;
 class TMOGUILineResizer;
 
 /*! \class TMOGUIInfoPanel	
@@ -27,7 +29,7 @@ public:
 	//! Destructor
     ~TMOGUIInfoPanel();
 
-	QGroupBox* groupBoxHisto;
+	Q3GroupBox* groupBoxHisto;
     QLabel* textLabelBlack;
 	QLabel* textLabelWhite;
     QLabel* textLabelGammma;
@@ -37,7 +39,7 @@ public:
 	QLabel* pGamma;
     QLabel* pAverage;
 	TMOGUILineResizer* line1;
-    QGroupBox* groupBoxStat;
+    Q3GroupBox* groupBoxStat;
     QLabel* textLabelBelow;
     QLabel* textLabelAbove;
     QLabel* textLabelVisible;
@@ -47,7 +49,7 @@ public:
     QLabel* pVisible;    
     QLabel* pExtreme;
 	TMOGUILineResizer* line2;
-    QGroupBox* groupBoxLocalTool;
+    Q3GroupBox* groupBoxLocalTool;
 	QLabel* textLabelNeighb;
 	QLabel* textLabelAvgLum;
 	QLabel* textLabelMinLum;
diff --git a/TMOgui/TMOGUIInfoTool.cpp b/TMOgui/TMOGUIInfoTool.cpp
index fde3add..2be4d96 100644
--- a/TMOgui/TMOGUIInfoTool.cpp
+++ b/TMOgui/TMOGUIInfoTool.cpp
@@ -9,6 +9,8 @@
 #include <qlineedit.h>
 #include <qscrollbar.h>
 #include <qradiobutton.h>
+//Added by qt3to4:
+#include <QMouseEvent>
 #include "resources6.h"
 
 TMOGUIInfoTool::TMOGUIInfoTool(QObject * parent, const char * name) : QObject(parent, name)
@@ -17,7 +19,7 @@ TMOGUIInfoTool::TMOGUIInfoTool(QObject * parent, const char * name) : QObject(pa
 	enableTool = false;
 	Reset();
 	contextDialogEnable = false;	
-	toolContext = new TMOGUITool((QWidget*)parent, 0, 0, WType_Popup);
+	toolContext = new TMOGUITool((QWidget*)parent, 0, 0, Qt::WType_Popup);
 	connect( toolContext->scrollBar, SIGNAL( valueChanged(int) ), this, SLOT( changeSize(int) ) );
 	connect( toolContext->editSize, SIGNAL( textChanged(const QString &) ), this, SLOT( changeTextSize(const QString &) ) );
 	connect( toolContext->radioCircle, SIGNAL( toggled(bool) ), this, SLOT( changeCircle(bool) ) );
diff --git a/TMOgui/TMOGUIInfoTool.h b/TMOgui/TMOGUIInfoTool.h
index 0573537..d0173c8 100644
--- a/TMOgui/TMOGUIInfoTool.h
+++ b/TMOgui/TMOGUIInfoTool.h
@@ -2,6 +2,8 @@
 #define __INFOTOOL_H
 
 #include <qobject.h>
+//Added by qt3to4:
+#include <QMouseEvent>
 
 class TMOGUIBitmap;
 class TMOGUITool;
diff --git a/TMOgui/TMOGUIInfoToolBar.cpp b/TMOgui/TMOGUIInfoToolBar.cpp
index 0d5496f..022a2ad 100644
--- a/TMOgui/TMOGUIInfoToolBar.cpp
+++ b/TMOgui/TMOGUIInfoToolBar.cpp
@@ -7,14 +7,14 @@
 #include <qtoolbutton.h>
 #include <qlabel.h>
 #include <qworkspace.h>
-#include <qpopupmenu.h>
+#include <q3popupmenu.h>
 
 
 //////////////////////////////////////////////////////////////////////
 // Construction/Destruction
 //////////////////////////////////////////////////////////////////////
 
-TMOGUIInfoToolBar::TMOGUIInfoToolBar(QWidget * parent, const char * name):QToolBar((QMainWindow*)parent, name)
+TMOGUIInfoToolBar::TMOGUIInfoToolBar(QWidget * parent, const char * name):Q3ToolBar((Q3MainWindow*)parent, name)
 {
 	pParent = parent;
 	Create();
diff --git a/TMOgui/TMOGUIInfoToolBar.h b/TMOgui/TMOGUIInfoToolBar.h
index 8c11385..a39eeab 100644
--- a/TMOgui/TMOGUIInfoToolBar.h
+++ b/TMOgui/TMOGUIInfoToolBar.h
@@ -4,7 +4,7 @@
 #ifndef __TMOGUIINFOTOOLBAR_H
 #define __TMOGUIINFOTOOLBAR_H
 
-#include <qtoolbar.h>
+#include <q3toolbar.h>
 
 class QWorkspace;
 class QToolButton;
@@ -15,7 +15,7 @@ class QToolButton;
  * Consists of two buttons. The first one activates the tool, the second shows tool's setting panel. 
  * Inherits from QToolBar.
  */
-class TMOGUIInfoToolBar : public QToolBar
+class TMOGUIInfoToolBar : public Q3ToolBar
 {
 	Q_OBJECT
 public:
diff --git a/TMOgui/TMOGUILineResizer.cpp b/TMOgui/TMOGUILineResizer.cpp
index 00f4f5b..8c09fad 100644
--- a/TMOgui/TMOGUILineResizer.cpp
+++ b/TMOgui/TMOGUILineResizer.cpp
@@ -1,16 +1,19 @@
 
 #include "TMOGUILineResizer.h"
 #include <qcursor.h>
+//Added by qt3to4:
+#include <QMouseEvent>
+#include <Q3Frame>
 
-TMOGUILineResizer::TMOGUILineResizer( QWidget* parent, const char* name, WFlags fl )
-    : QFrame( parent, name, fl )
+TMOGUILineResizer::TMOGUILineResizer( QWidget* parent, const char* name, Qt::WFlags fl )
+    : Q3Frame( parent, name, fl )
 {
 	pParent = parent;
     this->setCursor( QCursor( 6 ) );
     this->setMouseTracking( TRUE );
     this->setAcceptDrops( TRUE );
-    this->setFrameShape( QFrame::VLine );
-	this->setFrameShadow( QFrame::Raised );
+    this->setFrameShape( Q3Frame::VLine );
+	this->setFrameShadow( Q3Frame::Raised );
 	this->setLineWidth(2);
 	pressed = false;
 	minWidth = 0;
diff --git a/TMOgui/TMOGUILineResizer.h b/TMOgui/TMOGUILineResizer.h
index 6f76d67..b8ec9a5 100644
--- a/TMOgui/TMOGUILineResizer.h
+++ b/TMOgui/TMOGUILineResizer.h
@@ -2,7 +2,9 @@
 #ifndef TMOGUILINERESIZER_H
 #define TMOGUILINERESIZER_H
 
-#include <qframe.h>
+#include <q3frame.h>
+//Added by qt3to4:
+#include <QMouseEvent>
 
 class QWidget;
 
@@ -11,7 +13,7 @@ class QWidget;
  *
  * It's a new element used for resizing rows in info panel. Resizes whole groupBox. Inherits from QFrame.
  */
-class TMOGUILineResizer : public QFrame
+class TMOGUILineResizer : public Q3Frame
 {
     Q_OBJECT
 
@@ -24,7 +26,7 @@ public:
 	* \param name Optinonal name
 	* \param fl Optional flags
 	*/
-    TMOGUILineResizer( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
+    TMOGUILineResizer( QWidget* parent = 0, const char* name = 0, Qt::WFlags fl = 0 );
 	//! Destructor	
     ~TMOGUILineResizer();
 	//! Sets minimal width of parent element
